/*
 * Copyright [2011] [Risk Focus Inc]
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.riskfocus.util.daterangedsl;

import java.util.Calendar;

/**
 * Container to hold a date range. Enforces that range start is less than or equal to range end.
 * @author Risk Focus Inc.
 *
 */
public class DateRange {
	Calendar from;
	Calendar to;

	public DateRange(Calendar from, Calendar to) throws Exception 
	{
		super();
		
		if (to == null || from == null ) throw new Exception("'from' and 'to' cannot be null");
		if (from.after(to)) throw new Exception("'from' cannot be after 'to'");
		
		this.from = from;
		this.to = to;
	}

	public Calendar getFrom() {
		return from;
	}

	public Calendar getTo() {
		return to;
	}
}
