/*
 * Copyright [2011] [Risk Focus Inc]
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.riskfocus.util.daterangedsl.parser;

import org.antlr.runtime.BaseRecognizer;
import org.antlr.runtime.CharStream;
import org.antlr.runtime.DFA;
import org.antlr.runtime.EarlyExitException;
import org.antlr.runtime.Lexer;
import org.antlr.runtime.NoViableAltException;
import org.antlr.runtime.RecognitionException;
import org.antlr.runtime.RecognizerSharedState;

public class DateRangeDslLexer extends Lexer {
	public static final int EOF = -1;
	public static final int T__10 = 10;
	public static final int T__11 = 11;
	public static final int T__12 = 12;
	public static final int T__13 = 13;
	public static final int T__14 = 14;
	public static final int T__15 = 15;
	public static final int T__16 = 16;
	public static final int T__17 = 17;
	public static final int RANGESTART = 4;
	public static final int RANGEEND = 5;
	public static final int RELATIVE = 6;
	public static final int ABSOLUTE = 7;
	public static final int Number = 8;
	public static final int Period = 9;

	// delegates
	// delegators

	public DateRangeDslLexer() {
		;
	}

	public DateRangeDslLexer(CharStream input) {
		this(input, new RecognizerSharedState());
	}

	public DateRangeDslLexer(CharStream input, RecognizerSharedState state) {
		super(input, state);

	}

	public String getGrammarFileName() {
		return "C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g";
	}

	// $ANTLR start "RANGESTART"
	public final void mRANGESTART() throws RecognitionException {
		try {
			int _type = RANGESTART;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:3:12:
			// ( 'from' )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:3:14:
			// 'from'
			{
				match("from");

			}

			state.type = _type;
			state.channel = _channel;
		} finally {
		}
	}

	// $ANTLR end "RANGESTART"

	// $ANTLR start "RANGEEND"
	public final void mRANGEEND() throws RecognitionException {
		try {
			int _type = RANGEEND;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:4:10:
			// ( 'to' )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:4:12:
			// 'to'
			{
				match("to");

			}

			state.type = _type;
			state.channel = _channel;
		} finally {
		}
	}

	// $ANTLR end "RANGEEND"

	// $ANTLR start "RELATIVE"
	public final void mRELATIVE() throws RecognitionException {
		try {
			int _type = RELATIVE;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:5:10:
			// ( 'relative' )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:5:12:
			// 'relative'
			{
				match("relative");

			}

			state.type = _type;
			state.channel = _channel;
		} finally {
		}
	}

	// $ANTLR end "RELATIVE"

	// $ANTLR start "ABSOLUTE"
	public final void mABSOLUTE() throws RecognitionException {
		try {
			int _type = ABSOLUTE;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:6:10:
			// ( 'absolute' )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:6:12:
			// 'absolute'
			{
				match("absolute");

			}

			state.type = _type;
			state.channel = _channel;
		} finally {
		}
	}

	// $ANTLR end "ABSOLUTE"

	// $ANTLR start "T__10"
	public final void mT__10() throws RecognitionException {
		try {
			int _type = T__10;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:7:7:
			// ( '/from/' )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:7:9:
			// '/from/'
			{
				match("/from/");

			}

			state.type = _type;
			state.channel = _channel;
		} finally {
		}
	}

	// $ANTLR end "T__10"

	// $ANTLR start "T__11"
	public final void mT__11() throws RecognitionException {
		try {
			int _type = T__11;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:8:7:
			// ( '/to/' )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:8:9:
			// '/to/'
			{
				match("/to/");

			}

			state.type = _type;
			state.channel = _channel;
		} finally {
		}
	}

	// $ANTLR end "T__11"

	// $ANTLR start "T__12"
	public final void mT__12() throws RecognitionException {
		try {
			int _type = T__12;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:9:7:
			// ( 'yesterday' )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:9:9:
			// 'yesterday'
			{
				match("yesterday");

			}

			state.type = _type;
			state.channel = _channel;
		} finally {
		}
	}

	// $ANTLR end "T__12"

	// $ANTLR start "T__13"
	public final void mT__13() throws RecognitionException {
		try {
			int _type = T__13;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:10:7:
			// ( '/' )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:10:9:
			// '/'
			{
				match('/');

			}

			state.type = _type;
			state.channel = _channel;
		} finally {
		}
	}

	// $ANTLR end "T__13"

	// $ANTLR start "T__14"
	public final void mT__14() throws RecognitionException {
		try {
			int _type = T__14;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:11:7:
			// ( '/back' )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:11:9:
			// '/back'
			{
				match("/back");

			}

			state.type = _type;
			state.channel = _channel;
		} finally {
		}
	}

	// $ANTLR end "T__14"

	// $ANTLR start "T__15"
	public final void mT__15() throws RecognitionException {
		try {
			int _type = T__15;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:12:7:
			// ( '/thistime' )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:12:9:
			// '/thistime'
			{
				match("/thistime");

			}

			state.type = _type;
			state.channel = _channel;
		} finally {
		}
	}

	// $ANTLR end "T__15"

	// $ANTLR start "T__16"
	public final void mT__16() throws RecognitionException {
		try {
			int _type = T__16;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:13:7:
			// ( 'now' )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:13:9:
			// 'now'
			{
				match("now");

			}

			state.type = _type;
			state.channel = _channel;
		} finally {
		}
	}

	// $ANTLR end "T__16"

	// $ANTLR start "T__17"
	public final void mT__17() throws RecognitionException {
		try {
			int _type = T__17;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:14:7:
			// ( '/later' )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:14:9:
			// '/later'
			{
				match("/later");

			}

			state.type = _type;
			state.channel = _channel;
		} finally {
		}
	}

	// $ANTLR end "T__17"

	// $ANTLR start "Period"
	public final void mPeriod() throws RecognitionException {
		try {
			int _type = Period;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:50:7:
			// ( 'seconds' | 'minutes' | 'hours' | 'days' | 'weeks' | 'months' |
			// 'years' )
			int alt1 = 7;
			switch (input.LA(1)) {
			case 's': {
				alt1 = 1;
			}
				break;
			case 'm': {
				int LA1_2 = input.LA(2);

				if ((LA1_2 == 'i')) {
					alt1 = 2;
				} else if ((LA1_2 == 'o')) {
					alt1 = 6;
				} else {
					NoViableAltException nvae = new NoViableAltException("", 1,
							2, input);

					throw nvae;
				}
			}
				break;
			case 'h': {
				alt1 = 3;
			}
				break;
			case 'd': {
				alt1 = 4;
			}
				break;
			case 'w': {
				alt1 = 5;
			}
				break;
			case 'y': {
				alt1 = 7;
			}
				break;
			default:
				NoViableAltException nvae = new NoViableAltException("", 1, 0,
						input);

				throw nvae;
			}

			switch (alt1) {
			case 1:
				// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:50:9:
				// 'seconds'
			{
				match("seconds");

			}
				break;
			case 2:
				// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:50:21:
				// 'minutes'
			{
				match("minutes");

			}
				break;
			case 3:
				// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:50:33:
				// 'hours'
			{
				match("hours");

			}
				break;
			case 4:
				// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:50:43:
				// 'days'
			{
				match("days");

			}
				break;
			case 5:
				// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:50:52:
				// 'weeks'
			{
				match("weeks");

			}
				break;
			case 6:
				// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:50:62:
				// 'months'
			{
				match("months");

			}
				break;
			case 7:
				// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:50:73:
				// 'years'
			{
				match("years");

			}
				break;

			}
			state.type = _type;
			state.channel = _channel;
		} finally {
		}
	}

	// $ANTLR end "Period"

	// $ANTLR start "Number"
	public final void mNumber() throws RecognitionException {
		try {
			int _type = Number;
			int _channel = DEFAULT_TOKEN_CHANNEL;
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:54:7:
			// ( ( '0' .. '9' )+ )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:54:9:
			// ( '0' .. '9' )+
			{
				// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:54:9:
				// ( '0' .. '9' )+
				int cnt2 = 0;
				loop2: do {
					int alt2 = 2;
					int LA2_0 = input.LA(1);

					if (((LA2_0 >= '0' && LA2_0 <= '9'))) {
						alt2 = 1;
					}

					switch (alt2) {
					case 1:
						// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:54:10:
						// '0' .. '9'
					{
						matchRange('0', '9');

					}
						break;

					default:
						if (cnt2 >= 1)
							break loop2;
						EarlyExitException eee = new EarlyExitException(2,
								input);
						throw eee;
					}
					cnt2++;
				} while (true);

			}

			state.type = _type;
			state.channel = _channel;
		} finally {
		}
	}

	// $ANTLR end "Number"

	public void mTokens() throws RecognitionException {
		// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:1:8:
		// ( RANGESTART | RANGEEND | RELATIVE | ABSOLUTE | T__10 | T__11 | T__12
		// | T__13 | T__14 | T__15 | T__16 | T__17 | Period | Number )
		int alt3 = 14;
		alt3 = dfa3.predict(input);
		switch (alt3) {
		case 1:
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:1:10:
			// RANGESTART
		{
			mRANGESTART();

		}
			break;
		case 2:
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:1:21:
			// RANGEEND
		{
			mRANGEEND();

		}
			break;
		case 3:
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:1:30:
			// RELATIVE
		{
			mRELATIVE();

		}
			break;
		case 4:
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:1:39:
			// ABSOLUTE
		{
			mABSOLUTE();

		}
			break;
		case 5:
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:1:48:
			// T__10
		{
			mT__10();

		}
			break;
		case 6:
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:1:54:
			// T__11
		{
			mT__11();

		}
			break;
		case 7:
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:1:60:
			// T__12
		{
			mT__12();

		}
			break;
		case 8:
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:1:66:
			// T__13
		{
			mT__13();

		}
			break;
		case 9:
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:1:72:
			// T__14
		{
			mT__14();

		}
			break;
		case 10:
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:1:78:
			// T__15
		{
			mT__15();

		}
			break;
		case 11:
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:1:84:
			// T__16
		{
			mT__16();

		}
			break;
		case 12:
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:1:90:
			// T__17
		{
			mT__17();

		}
			break;
		case 13:
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:1:96:
			// Period
		{
			mPeriod();

		}
			break;
		case 14:
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:1:103:
			// Number
		{
			mNumber();

		}
			break;

		}

	}

	protected DFA3 dfa3 = new DFA3(this);
	static final String DFA3_eotS = "\5\uffff\1\16\15\uffff";
	static final String DFA3_eofS = "\23\uffff";
	static final String DFA3_minS = "\1\57\4\uffff\1\142\1\145\4\uffff\1\150\3\uffff\1\141\3\uffff";
	static final String DFA3_maxS = "\1\171\4\uffff\1\164\1\145\4\uffff\1\157\3\uffff\1\163\3\uffff";
	static final String DFA3_acceptS = "\1\uffff\1\1\1\2\1\3\1\4\2\uffff\1\13\1\15\1\16\1\5\1\uffff\1\11"
			+ "\1\14\1\10\1\uffff\1\6\1\12\1\7";
	static final String DFA3_specialS = "\23\uffff}>";
	static final String[] DFA3_transitionS = {
			"\1\5\12\11\47\uffff\1\4\2\uffff\1\10\1\uffff\1\1\1\uffff\1"
					+ "\10\4\uffff\1\10\1\7\3\uffff\1\3\1\10\1\2\2\uffff\1\10\1\uffff"
					+ "\1\6", "", "", "", "",
			"\1\14\3\uffff\1\12\5\uffff\1\15\7\uffff\1\13", "\1\17", "", "",
			"", "", "\1\21\6\uffff\1\20", "", "", "", "\1\10\21\uffff\1\22",
			"", "", "" };

	static final short[] DFA3_eot = DFA.unpackEncodedString(DFA3_eotS);
	static final short[] DFA3_eof = DFA.unpackEncodedString(DFA3_eofS);
	static final char[] DFA3_min = DFA
			.unpackEncodedStringToUnsignedChars(DFA3_minS);
	static final char[] DFA3_max = DFA
			.unpackEncodedStringToUnsignedChars(DFA3_maxS);
	static final short[] DFA3_accept = DFA.unpackEncodedString(DFA3_acceptS);
	static final short[] DFA3_special = DFA.unpackEncodedString(DFA3_specialS);
	static final short[][] DFA3_transition;

	static {
		int numStates = DFA3_transitionS.length;
		DFA3_transition = new short[numStates][];
		for (int i = 0; i < numStates; i++) {
			DFA3_transition[i] = DFA.unpackEncodedString(DFA3_transitionS[i]);
		}
	}

	class DFA3 extends DFA {

		public DFA3(BaseRecognizer recognizer) {
			this.recognizer = recognizer;
			this.decisionNumber = 3;
			this.eot = DFA3_eot;
			this.eof = DFA3_eof;
			this.min = DFA3_min;
			this.max = DFA3_max;
			this.accept = DFA3_accept;
			this.special = DFA3_special;
			this.transition = DFA3_transition;
		}

		public String getDescription() {
			return "1:1: Tokens : ( RANGESTART | RANGEEND | RELATIVE | ABSOLUTE | T__10 | T__11 | T__12 | T__13 | T__14 | T__15 | T__16 | T__17 | Period | Number );";
		}
	}

}