/*
 * Copyright [2011] [Risk Focus Inc]
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.riskfocus.util.daterangedsl.parser;

import org.antlr.runtime.BitSet;
import org.antlr.runtime.NoViableAltException;
import org.antlr.runtime.Parser;
import org.antlr.runtime.ParserRuleReturnScope;
import org.antlr.runtime.RecognitionException;
import org.antlr.runtime.RecognizerSharedState;
import org.antlr.runtime.Token;
import org.antlr.runtime.TokenStream;
import org.antlr.runtime.tree.CommonTreeAdaptor;
import org.antlr.runtime.tree.RewriteRuleSubtreeStream;
import org.antlr.runtime.tree.RewriteRuleTokenStream;
import org.antlr.runtime.tree.TreeAdaptor;

public class DateRangeDslParser extends Parser {
	public static final String[] tokenNames = new String[] { "<invalid>",
			"<EOR>", "<DOWN>", "<UP>", "RANGESTART", "RANGEEND", "RELATIVE",
			"ABSOLUTE", "Number", "Period", "'/from/'", "'/to/'",
			"'yesterday'", "'/'", "'/back'", "'/thistime'", "'now'", "'/later'" };
	public static final int EOF = -1;
	public static final int T__10 = 10;
	public static final int T__11 = 11;
	public static final int T__12 = 12;
	public static final int T__13 = 13;
	public static final int T__14 = 14;
	public static final int T__15 = 15;
	public static final int T__16 = 16;
	public static final int T__17 = 17;
	public static final int RANGESTART = 4;
	public static final int RANGEEND = 5;
	public static final int RELATIVE = 6;
	public static final int ABSOLUTE = 7;
	public static final int Number = 8;
	public static final int Period = 9;

	// delegates
	// delegators

	public DateRangeDslParser(TokenStream input) {
		this(input, new RecognizerSharedState());
	}

	public DateRangeDslParser(TokenStream input, RecognizerSharedState state) {
		super(input, state);

	}

	protected TreeAdaptor adaptor = new CommonTreeAdaptor();

	public void setTreeAdaptor(TreeAdaptor adaptor) {
		this.adaptor = adaptor;
	}

	public TreeAdaptor getTreeAdaptor() {
		return adaptor;
	}

	public String[] getTokenNames() {
		return DateRangeDslParser.tokenNames;
	}

	public String getGrammarFileName() {
		return "C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g";
	}

	public static class dateRangeModel_return extends ParserRuleReturnScope {
		Object tree;

		public Object getTree() {
			return tree;
		}
	};

	// $ANTLR start "dateRangeModel"
	// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:32:1:
	// dateRangeModel : '/from/' rangeBegin '/to/' rangeEnd -> 'from' rangeBegin
	// 'to' rangeEnd ;
	public final DateRangeDslParser.dateRangeModel_return dateRangeModel()
			throws RecognitionException {
		DateRangeDslParser.dateRangeModel_return retval = new DateRangeDslParser.dateRangeModel_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		Token string_literal1 = null;
		Token string_literal3 = null;
		DateRangeDslParser.rangeBegin_return rangeBegin2 = null;

		DateRangeDslParser.rangeEnd_return rangeEnd4 = null;

		Object string_literal1_tree = null;
		Object string_literal3_tree = null;
		RewriteRuleTokenStream stream_10 = new RewriteRuleTokenStream(adaptor,
				"token 10");
		RewriteRuleTokenStream stream_11 = new RewriteRuleTokenStream(adaptor,
				"token 11");
		RewriteRuleSubtreeStream stream_rangeEnd = new RewriteRuleSubtreeStream(
				adaptor, "rule rangeEnd");
		RewriteRuleSubtreeStream stream_rangeBegin = new RewriteRuleSubtreeStream(
				adaptor, "rule rangeBegin");
		try {
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:32:15:
			// ( '/from/' rangeBegin '/to/' rangeEnd -> 'from' rangeBegin 'to'
			// rangeEnd )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:32:17:
			// '/from/' rangeBegin '/to/' rangeEnd
			{
				string_literal1 = (Token) match(input, 10,
						FOLLOW_10_in_dateRangeModel60);
				stream_10.add(string_literal1);

				pushFollow(FOLLOW_rangeBegin_in_dateRangeModel62);
				rangeBegin2 = rangeBegin();

				state._fsp--;

				stream_rangeBegin.add(rangeBegin2.getTree());
				string_literal3 = (Token) match(input, 11,
						FOLLOW_11_in_dateRangeModel64);
				stream_11.add(string_literal3);

				pushFollow(FOLLOW_rangeEnd_in_dateRangeModel66);
				rangeEnd4 = rangeEnd();

				state._fsp--;

				stream_rangeEnd.add(rangeEnd4.getTree());

				// AST REWRITE
				// elements: rangeEnd, RANGESTART, rangeBegin, RANGEEND
				// token labels:
				// rule labels: retval
				// token list labels:
				// rule list labels:
				// wildcard labels:
				retval.tree = root_0;
				RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(
						adaptor, "rule retval", retval != null ? retval.tree
								: null);

				root_0 = (Object) adaptor.nil();
				// 32:53: -> 'from' rangeBegin 'to' rangeEnd
				{
					adaptor.addChild(root_0,
							(Object) adaptor.create(RANGESTART, "RANGESTART"));
					adaptor.addChild(root_0, stream_rangeBegin.nextTree());
					adaptor.addChild(root_0,
							(Object) adaptor.create(RANGEEND, "RANGEEND"));
					adaptor.addChild(root_0, stream_rangeEnd.nextTree());

				}

				retval.tree = root_0;
			}

			retval.stop = input.LT(-1);

			retval.tree = (Object) adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		} catch (RecognitionException re) {
			reportError(re);
			recover(input, re);
			retval.tree = (Object) adaptor.errorNode(input, retval.start,
					input.LT(-1), re);

		} finally {
		}
		return retval;
	}

	// $ANTLR end "dateRangeModel"

	public static class rangeBegin_return extends ParserRuleReturnScope {
		Object tree;

		public Object getTree() {
			return tree;
		}
	};

	// $ANTLR start "rangeBegin"
	// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:34:1:
	// rangeBegin : ( relativePeriodPast | absoluteDate ) thisTime ;
	public final DateRangeDslParser.rangeBegin_return rangeBegin()
			throws RecognitionException {
		DateRangeDslParser.rangeBegin_return retval = new DateRangeDslParser.rangeBegin_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		DateRangeDslParser.relativePeriodPast_return relativePeriodPast5 = null;

		DateRangeDslParser.absoluteDate_return absoluteDate6 = null;

		DateRangeDslParser.thisTime_return thisTime7 = null;

		try {
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:34:11:
			// ( ( relativePeriodPast | absoluteDate ) thisTime )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:34:13:
			// ( relativePeriodPast | absoluteDate ) thisTime
			{
				root_0 = (Object) adaptor.nil();

				// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:34:13:
				// ( relativePeriodPast | absoluteDate )
				int alt1 = 2;
				int LA1_0 = input.LA(1);

				if ((LA1_0 == 12)) {
					alt1 = 1;
				} else if ((LA1_0 == Number)) {
					int LA1_2 = input.LA(2);

					if ((LA1_2 == 13)) {
						alt1 = 1;
					} else if ((LA1_2 == 11 || LA1_2 == 15)) {
						alt1 = 2;
					} else {
						NoViableAltException nvae = new NoViableAltException(
								"", 1, 2, input);

						throw nvae;
					}
				} else {
					NoViableAltException nvae = new NoViableAltException("", 1,
							0, input);

					throw nvae;
				}
				switch (alt1) {
				case 1:
					// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:34:14:
					// relativePeriodPast
				{
					pushFollow(FOLLOW_relativePeriodPast_in_rangeBegin84);
					relativePeriodPast5 = relativePeriodPast();

					state._fsp--;

					adaptor.addChild(root_0, relativePeriodPast5.getTree());

				}
					break;
				case 2:
					// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:34:35:
					// absoluteDate
				{
					pushFollow(FOLLOW_absoluteDate_in_rangeBegin88);
					absoluteDate6 = absoluteDate();

					state._fsp--;

					adaptor.addChild(root_0, absoluteDate6.getTree());

				}
					break;

				}

				pushFollow(FOLLOW_thisTime_in_rangeBegin91);
				thisTime7 = thisTime();

				state._fsp--;

				adaptor.addChild(root_0, thisTime7.getTree());

			}

			retval.stop = input.LT(-1);

			retval.tree = (Object) adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		} catch (RecognitionException re) {
			reportError(re);
			recover(input, re);
			retval.tree = (Object) adaptor.errorNode(input, retval.start,
					input.LT(-1), re);

		} finally {
		}
		return retval;
	}

	// $ANTLR end "rangeBegin"

	public static class relativePeriodPast_return extends ParserRuleReturnScope {
		Object tree;

		public Object getTree() {
			return tree;
		}
	};

	// $ANTLR start "relativePeriodPast"
	// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:36:1:
	// relativePeriodPast : relativePeriodPastOptions -> 'relative'
	// relativePeriodPastOptions ;
	public final DateRangeDslParser.relativePeriodPast_return relativePeriodPast()
			throws RecognitionException {
		DateRangeDslParser.relativePeriodPast_return retval = new DateRangeDslParser.relativePeriodPast_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		DateRangeDslParser.relativePeriodPastOptions_return relativePeriodPastOptions8 = null;

		RewriteRuleSubtreeStream stream_relativePeriodPastOptions = new RewriteRuleSubtreeStream(
				adaptor, "rule relativePeriodPastOptions");
		try {
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:36:19:
			// ( relativePeriodPastOptions -> 'relative'
			// relativePeriodPastOptions )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:36:21:
			// relativePeriodPastOptions
			{
				pushFollow(FOLLOW_relativePeriodPastOptions_in_relativePeriodPast100);
				relativePeriodPastOptions8 = relativePeriodPastOptions();

				state._fsp--;

				stream_relativePeriodPastOptions.add(relativePeriodPastOptions8
						.getTree());

				// AST REWRITE
				// elements: relativePeriodPastOptions, RELATIVE
				// token labels:
				// rule labels: retval
				// token list labels:
				// rule list labels:
				// wildcard labels:
				retval.tree = root_0;
				RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(
						adaptor, "rule retval", retval != null ? retval.tree
								: null);

				root_0 = (Object) adaptor.nil();
				// 36:47: -> 'relative' relativePeriodPastOptions
				{
					adaptor.addChild(root_0,
							(Object) adaptor.create(RELATIVE, "RELATIVE"));
					adaptor.addChild(root_0,
							stream_relativePeriodPastOptions.nextTree());

				}

				retval.tree = root_0;
			}

			retval.stop = input.LT(-1);

			retval.tree = (Object) adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		} catch (RecognitionException re) {
			reportError(re);
			recover(input, re);
			retval.tree = (Object) adaptor.errorNode(input, retval.start,
					input.LT(-1), re);

		} finally {
		}
		return retval;
	}

	// $ANTLR end "relativePeriodPast"

	public static class relativePeriodPastOptions_return extends
			ParserRuleReturnScope {
		Object tree;

		public Object getTree() {
			return tree;
		}
	};

	// $ANTLR start "relativePeriodPastOptions"
	// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:38:1:
	// relativePeriodPastOptions : ( 'yesterday' | relativePeriodPastOption1 );
	public final DateRangeDslParser.relativePeriodPastOptions_return relativePeriodPastOptions()
			throws RecognitionException {
		DateRangeDslParser.relativePeriodPastOptions_return retval = new DateRangeDslParser.relativePeriodPastOptions_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		Token string_literal9 = null;
		DateRangeDslParser.relativePeriodPastOption1_return relativePeriodPastOption110 = null;

		Object string_literal9_tree = null;

		try {
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:38:26:
			// ( 'yesterday' | relativePeriodPastOption1 )
			int alt2 = 2;
			int LA2_0 = input.LA(1);

			if ((LA2_0 == 12)) {
				alt2 = 1;
			} else if ((LA2_0 == Number)) {
				alt2 = 2;
			} else {
				NoViableAltException nvae = new NoViableAltException("", 2, 0,
						input);

				throw nvae;
			}
			switch (alt2) {
			case 1:
				// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:38:28:
				// 'yesterday'
			{
				root_0 = (Object) adaptor.nil();

				string_literal9 = (Token) match(input, 12,
						FOLLOW_12_in_relativePeriodPastOptions114);
				string_literal9_tree = (Object) adaptor.create(string_literal9);
				adaptor.addChild(root_0, string_literal9_tree);

			}
				break;
			case 2:
				// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:38:42:
				// relativePeriodPastOption1
			{
				root_0 = (Object) adaptor.nil();

				pushFollow(FOLLOW_relativePeriodPastOption1_in_relativePeriodPastOptions118);
				relativePeriodPastOption110 = relativePeriodPastOption1();

				state._fsp--;

				adaptor.addChild(root_0, relativePeriodPastOption110.getTree());

			}
				break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (Object) adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		} catch (RecognitionException re) {
			reportError(re);
			recover(input, re);
			retval.tree = (Object) adaptor.errorNode(input, retval.start,
					input.LT(-1), re);

		} finally {
		}
		return retval;
	}

	// $ANTLR end "relativePeriodPastOptions"

	public static class relativePeriodPastOption1_return extends
			ParserRuleReturnScope {
		Object tree;

		public Object getTree() {
			return tree;
		}
	};

	// $ANTLR start "relativePeriodPastOption1"
	// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:40:1:
	// relativePeriodPastOption1 : Number '/' Period '/back' -> Number Period ;
	public final DateRangeDslParser.relativePeriodPastOption1_return relativePeriodPastOption1()
			throws RecognitionException {
		DateRangeDslParser.relativePeriodPastOption1_return retval = new DateRangeDslParser.relativePeriodPastOption1_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		Token Number11 = null;
		Token char_literal12 = null;
		Token Period13 = null;
		Token string_literal14 = null;

		Object Number11_tree = null;
		Object char_literal12_tree = null;
		Object Period13_tree = null;
		Object string_literal14_tree = null;
		RewriteRuleTokenStream stream_Period = new RewriteRuleTokenStream(
				adaptor, "token Period");
		RewriteRuleTokenStream stream_Number = new RewriteRuleTokenStream(
				adaptor, "token Number");
		RewriteRuleTokenStream stream_13 = new RewriteRuleTokenStream(adaptor,
				"token 13");
		RewriteRuleTokenStream stream_14 = new RewriteRuleTokenStream(adaptor,
				"token 14");

		try {
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:40:26:
			// ( Number '/' Period '/back' -> Number Period )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:40:28:
			// Number '/' Period '/back'
			{
				Number11 = (Token) match(input, Number,
						FOLLOW_Number_in_relativePeriodPastOption1126);
				stream_Number.add(Number11);

				char_literal12 = (Token) match(input, 13,
						FOLLOW_13_in_relativePeriodPastOption1128);
				stream_13.add(char_literal12);

				Period13 = (Token) match(input, Period,
						FOLLOW_Period_in_relativePeriodPastOption1130);
				stream_Period.add(Period13);

				string_literal14 = (Token) match(input, 14,
						FOLLOW_14_in_relativePeriodPastOption1132);
				stream_14.add(string_literal14);

				// AST REWRITE
				// elements: Number, Period
				// token labels:
				// rule labels: retval
				// token list labels:
				// rule list labels:
				// wildcard labels:
				retval.tree = root_0;
				RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(
						adaptor, "rule retval", retval != null ? retval.tree
								: null);

				root_0 = (Object) adaptor.nil();
				// 40:54: -> Number Period
				{
					adaptor.addChild(root_0, stream_Number.nextNode());
					adaptor.addChild(root_0, stream_Period.nextNode());

				}

				retval.tree = root_0;
			}

			retval.stop = input.LT(-1);

			retval.tree = (Object) adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		} catch (RecognitionException re) {
			reportError(re);
			recover(input, re);
			retval.tree = (Object) adaptor.errorNode(input, retval.start,
					input.LT(-1), re);

		} finally {
		}
		return retval;
	}

	// $ANTLR end "relativePeriodPastOption1"

	public static class thisTime_return extends ParserRuleReturnScope {
		Object tree;

		public Object getTree() {
			return tree;
		}
	};

	// $ANTLR start "thisTime"
	// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:42:1:
	// thisTime : ( '/thistime' )? ;
	public final DateRangeDslParser.thisTime_return thisTime()
			throws RecognitionException {
		DateRangeDslParser.thisTime_return retval = new DateRangeDslParser.thisTime_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		Token string_literal15 = null;

		Object string_literal15_tree = null;

		try {
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:42:9:
			// ( ( '/thistime' )? )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:42:11:
			// ( '/thistime' )?
			{
				root_0 = (Object) adaptor.nil();

				// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:42:11:
				// ( '/thistime' )?
				int alt3 = 2;
				int LA3_0 = input.LA(1);

				if ((LA3_0 == 15)) {
					alt3 = 1;
				}
				switch (alt3) {
				case 1:
					// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:42:11:
					// '/thistime'
				{
					string_literal15 = (Token) match(input, 15,
							FOLLOW_15_in_thisTime145);
					string_literal15_tree = (Object) adaptor
							.create(string_literal15);
					adaptor.addChild(root_0, string_literal15_tree);

				}
					break;

				}

			}

			retval.stop = input.LT(-1);

			retval.tree = (Object) adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		} catch (RecognitionException re) {
			reportError(re);
			recover(input, re);
			retval.tree = (Object) adaptor.errorNode(input, retval.start,
					input.LT(-1), re);

		} finally {
		}
		return retval;
	}

	// $ANTLR end "thisTime"

	public static class rangeEnd_return extends ParserRuleReturnScope {
		Object tree;

		public Object getTree() {
			return tree;
		}
	};

	// $ANTLR start "rangeEnd"
	// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:44:1:
	// rangeEnd : ( ( ( relativePeriodFuture | absoluteDate ) thisTime ) | 'now'
	// );
	public final DateRangeDslParser.rangeEnd_return rangeEnd()
			throws RecognitionException {
		DateRangeDslParser.rangeEnd_return retval = new DateRangeDslParser.rangeEnd_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		Token string_literal19 = null;
		DateRangeDslParser.relativePeriodFuture_return relativePeriodFuture16 = null;

		DateRangeDslParser.absoluteDate_return absoluteDate17 = null;

		DateRangeDslParser.thisTime_return thisTime18 = null;

		Object string_literal19_tree = null;

		try {
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:44:9:
			// ( ( ( relativePeriodFuture | absoluteDate ) thisTime ) | 'now' )
			int alt5 = 2;
			int LA5_0 = input.LA(1);

			if ((LA5_0 == Number)) {
				alt5 = 1;
			} else if ((LA5_0 == 16)) {
				alt5 = 2;
			} else {
				NoViableAltException nvae = new NoViableAltException("", 5, 0,
						input);

				throw nvae;
			}
			switch (alt5) {
			case 1:
				// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:44:11:
				// ( ( relativePeriodFuture | absoluteDate ) thisTime )
			{
				root_0 = (Object) adaptor.nil();

				// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:44:11:
				// ( ( relativePeriodFuture | absoluteDate ) thisTime )
				// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:44:12:
				// ( relativePeriodFuture | absoluteDate ) thisTime
				{
					// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:44:12:
					// ( relativePeriodFuture | absoluteDate )
					int alt4 = 2;
					int LA4_0 = input.LA(1);

					if ((LA4_0 == Number)) {
						int LA4_1 = input.LA(2);

						if ((LA4_1 == 13)) {
							alt4 = 1;
						} else if ((LA4_1 == EOF || LA4_1 == 15)) {
							alt4 = 2;
						} else {
							NoViableAltException nvae = new NoViableAltException(
									"", 4, 1, input);

							throw nvae;
						}
					} else {
						NoViableAltException nvae = new NoViableAltException(
								"", 4, 0, input);

						throw nvae;
					}
					switch (alt4) {
					case 1:
						// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:44:13:
						// relativePeriodFuture
					{
						pushFollow(FOLLOW_relativePeriodFuture_in_rangeEnd155);
						relativePeriodFuture16 = relativePeriodFuture();

						state._fsp--;

						adaptor.addChild(root_0,
								relativePeriodFuture16.getTree());

					}
						break;
					case 2:
						// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:44:36:
						// absoluteDate
					{
						pushFollow(FOLLOW_absoluteDate_in_rangeEnd159);
						absoluteDate17 = absoluteDate();

						state._fsp--;

						adaptor.addChild(root_0, absoluteDate17.getTree());

					}
						break;

					}

					pushFollow(FOLLOW_thisTime_in_rangeEnd162);
					thisTime18 = thisTime();

					state._fsp--;

					adaptor.addChild(root_0, thisTime18.getTree());

				}

			}
				break;
			case 2:
				// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:44:62:
				// 'now'
			{
				root_0 = (Object) adaptor.nil();

				string_literal19 = (Token) match(input, 16,
						FOLLOW_16_in_rangeEnd167);
				string_literal19_tree = (Object) adaptor
						.create(string_literal19);
				adaptor.addChild(root_0, string_literal19_tree);

			}
				break;

			}
			retval.stop = input.LT(-1);

			retval.tree = (Object) adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		} catch (RecognitionException re) {
			reportError(re);
			recover(input, re);
			retval.tree = (Object) adaptor.errorNode(input, retval.start,
					input.LT(-1), re);

		} finally {
		}
		return retval;
	}

	// $ANTLR end "rangeEnd"

	public static class relativePeriodFuture_return extends
			ParserRuleReturnScope {
		Object tree;

		public Object getTree() {
			return tree;
		}
	};

	// $ANTLR start "relativePeriodFuture"
	// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:46:1:
	// relativePeriodFuture : relativePeriodFutureOptions -> 'relative'
	// relativePeriodFutureOptions ;
	public final DateRangeDslParser.relativePeriodFuture_return relativePeriodFuture()
			throws RecognitionException {
		DateRangeDslParser.relativePeriodFuture_return retval = new DateRangeDslParser.relativePeriodFuture_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		DateRangeDslParser.relativePeriodFutureOptions_return relativePeriodFutureOptions20 = null;

		RewriteRuleSubtreeStream stream_relativePeriodFutureOptions = new RewriteRuleSubtreeStream(
				adaptor, "rule relativePeriodFutureOptions");
		try {
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:46:21:
			// ( relativePeriodFutureOptions -> 'relative'
			// relativePeriodFutureOptions )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:46:23:
			// relativePeriodFutureOptions
			{
				pushFollow(FOLLOW_relativePeriodFutureOptions_in_relativePeriodFuture174);
				relativePeriodFutureOptions20 = relativePeriodFutureOptions();

				state._fsp--;

				stream_relativePeriodFutureOptions
						.add(relativePeriodFutureOptions20.getTree());

				// AST REWRITE
				// elements: RELATIVE, relativePeriodFutureOptions
				// token labels:
				// rule labels: retval
				// token list labels:
				// rule list labels:
				// wildcard labels:
				retval.tree = root_0;
				RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(
						adaptor, "rule retval", retval != null ? retval.tree
								: null);

				root_0 = (Object) adaptor.nil();
				// 46:51: -> 'relative' relativePeriodFutureOptions
				{
					adaptor.addChild(root_0,
							(Object) adaptor.create(RELATIVE, "RELATIVE"));
					adaptor.addChild(root_0,
							stream_relativePeriodFutureOptions.nextTree());

				}

				retval.tree = root_0;
			}

			retval.stop = input.LT(-1);

			retval.tree = (Object) adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		} catch (RecognitionException re) {
			reportError(re);
			recover(input, re);
			retval.tree = (Object) adaptor.errorNode(input, retval.start,
					input.LT(-1), re);

		} finally {
		}
		return retval;
	}

	// $ANTLR end "relativePeriodFuture"

	public static class relativePeriodFutureOptions_return extends
			ParserRuleReturnScope {
		Object tree;

		public Object getTree() {
			return tree;
		}
	};

	// $ANTLR start "relativePeriodFutureOptions"
	// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:48:1:
	// relativePeriodFutureOptions : Number '/' Period '/later' -> Number Period
	// ;
	public final DateRangeDslParser.relativePeriodFutureOptions_return relativePeriodFutureOptions()
			throws RecognitionException {
		DateRangeDslParser.relativePeriodFutureOptions_return retval = new DateRangeDslParser.relativePeriodFutureOptions_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		Token Number21 = null;
		Token char_literal22 = null;
		Token Period23 = null;
		Token string_literal24 = null;

		Object Number21_tree = null;
		Object char_literal22_tree = null;
		Object Period23_tree = null;
		Object string_literal24_tree = null;
		RewriteRuleTokenStream stream_Period = new RewriteRuleTokenStream(
				adaptor, "token Period");
		RewriteRuleTokenStream stream_Number = new RewriteRuleTokenStream(
				adaptor, "token Number");
		RewriteRuleTokenStream stream_17 = new RewriteRuleTokenStream(adaptor,
				"token 17");
		RewriteRuleTokenStream stream_13 = new RewriteRuleTokenStream(adaptor,
				"token 13");

		try {
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:48:28:
			// ( Number '/' Period '/later' -> Number Period )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:48:30:
			// Number '/' Period '/later'
			{
				Number21 = (Token) match(input, Number,
						FOLLOW_Number_in_relativePeriodFutureOptions187);
				stream_Number.add(Number21);

				char_literal22 = (Token) match(input, 13,
						FOLLOW_13_in_relativePeriodFutureOptions189);
				stream_13.add(char_literal22);

				Period23 = (Token) match(input, Period,
						FOLLOW_Period_in_relativePeriodFutureOptions191);
				stream_Period.add(Period23);

				string_literal24 = (Token) match(input, 17,
						FOLLOW_17_in_relativePeriodFutureOptions193);
				stream_17.add(string_literal24);

				// AST REWRITE
				// elements: Number, Period
				// token labels:
				// rule labels: retval
				// token list labels:
				// rule list labels:
				// wildcard labels:
				retval.tree = root_0;
				RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(
						adaptor, "rule retval", retval != null ? retval.tree
								: null);

				root_0 = (Object) adaptor.nil();
				// 48:57: -> Number Period
				{
					adaptor.addChild(root_0, stream_Number.nextNode());
					adaptor.addChild(root_0, stream_Period.nextNode());

				}

				retval.tree = root_0;
			}

			retval.stop = input.LT(-1);

			retval.tree = (Object) adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		} catch (RecognitionException re) {
			reportError(re);
			recover(input, re);
			retval.tree = (Object) adaptor.errorNode(input, retval.start,
					input.LT(-1), re);

		} finally {
		}
		return retval;
	}

	// $ANTLR end "relativePeriodFutureOptions"

	public static class absoluteDate_return extends ParserRuleReturnScope {
		Object tree;

		public Object getTree() {
			return tree;
		}
	};

	// $ANTLR start "absoluteDate"
	// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:52:1:
	// absoluteDate : Number -> 'absolute' Number ;
	public final DateRangeDslParser.absoluteDate_return absoluteDate()
			throws RecognitionException {
		DateRangeDslParser.absoluteDate_return retval = new DateRangeDslParser.absoluteDate_return();
		retval.start = input.LT(1);

		Object root_0 = null;

		Token Number25 = null;

		Object Number25_tree = null;
		RewriteRuleTokenStream stream_Number = new RewriteRuleTokenStream(
				adaptor, "token Number");

		try {
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:52:13:
			// ( Number -> 'absolute' Number )
			// C:\\projects\\date-range-dsl\\trunk\\src\\main\\resources\\DateRangeDsl.g:52:15:
			// Number
			{
				Number25 = (Token) match(input, Number,
						FOLLOW_Number_in_absoluteDate237);
				stream_Number.add(Number25);

				// AST REWRITE
				// elements: ABSOLUTE, Number
				// token labels:
				// rule labels: retval
				// token list labels:
				// rule list labels:
				// wildcard labels:
				retval.tree = root_0;
				RewriteRuleSubtreeStream stream_retval = new RewriteRuleSubtreeStream(
						adaptor, "rule retval", retval != null ? retval.tree
								: null);

				root_0 = (Object) adaptor.nil();
				// 52:22: -> 'absolute' Number
				{
					adaptor.addChild(root_0,
							(Object) adaptor.create(ABSOLUTE, "ABSOLUTE"));
					adaptor.addChild(root_0, stream_Number.nextNode());

				}

				retval.tree = root_0;
			}

			retval.stop = input.LT(-1);

			retval.tree = (Object) adaptor.rulePostProcessing(root_0);
			adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

		} catch (RecognitionException re) {
			reportError(re);
			recover(input, re);
			retval.tree = (Object) adaptor.errorNode(input, retval.start,
					input.LT(-1), re);

		} finally {
		}
		return retval;
	}

	// $ANTLR end "absoluteDate"

	// Delegated rules

	public static final BitSet FOLLOW_10_in_dateRangeModel60 = new BitSet(
			new long[] { 0x0000000000001100L });
	public static final BitSet FOLLOW_rangeBegin_in_dateRangeModel62 = new BitSet(
			new long[] { 0x0000000000000800L });
	public static final BitSet FOLLOW_11_in_dateRangeModel64 = new BitSet(
			new long[] { 0x0000000000011100L });
	public static final BitSet FOLLOW_rangeEnd_in_dateRangeModel66 = new BitSet(
			new long[] { 0x0000000000000002L });
	public static final BitSet FOLLOW_relativePeriodPast_in_rangeBegin84 = new BitSet(
			new long[] { 0x0000000000008000L });
	public static final BitSet FOLLOW_absoluteDate_in_rangeBegin88 = new BitSet(
			new long[] { 0x0000000000008000L });
	public static final BitSet FOLLOW_thisTime_in_rangeBegin91 = new BitSet(
			new long[] { 0x0000000000000002L });
	public static final BitSet FOLLOW_relativePeriodPastOptions_in_relativePeriodPast100 = new BitSet(
			new long[] { 0x0000000000000002L });
	public static final BitSet FOLLOW_12_in_relativePeriodPastOptions114 = new BitSet(
			new long[] { 0x0000000000000002L });
	public static final BitSet FOLLOW_relativePeriodPastOption1_in_relativePeriodPastOptions118 = new BitSet(
			new long[] { 0x0000000000000002L });
	public static final BitSet FOLLOW_Number_in_relativePeriodPastOption1126 = new BitSet(
			new long[] { 0x0000000000002000L });
	public static final BitSet FOLLOW_13_in_relativePeriodPastOption1128 = new BitSet(
			new long[] { 0x0000000000000200L });
	public static final BitSet FOLLOW_Period_in_relativePeriodPastOption1130 = new BitSet(
			new long[] { 0x0000000000004000L });
	public static final BitSet FOLLOW_14_in_relativePeriodPastOption1132 = new BitSet(
			new long[] { 0x0000000000000002L });
	public static final BitSet FOLLOW_15_in_thisTime145 = new BitSet(
			new long[] { 0x0000000000000002L });
	public static final BitSet FOLLOW_relativePeriodFuture_in_rangeEnd155 = new BitSet(
			new long[] { 0x0000000000008000L });
	public static final BitSet FOLLOW_absoluteDate_in_rangeEnd159 = new BitSet(
			new long[] { 0x0000000000008000L });
	public static final BitSet FOLLOW_thisTime_in_rangeEnd162 = new BitSet(
			new long[] { 0x0000000000000002L });
	public static final BitSet FOLLOW_16_in_rangeEnd167 = new BitSet(
			new long[] { 0x0000000000000002L });
	public static final BitSet FOLLOW_relativePeriodFutureOptions_in_relativePeriodFuture174 = new BitSet(
			new long[] { 0x0000000000000002L });
	public static final BitSet FOLLOW_Number_in_relativePeriodFutureOptions187 = new BitSet(
			new long[] { 0x0000000000002000L });
	public static final BitSet FOLLOW_13_in_relativePeriodFutureOptions189 = new BitSet(
			new long[] { 0x0000000000000200L });
	public static final BitSet FOLLOW_Period_in_relativePeriodFutureOptions191 = new BitSet(
			new long[] { 0x0000000000020000L });
	public static final BitSet FOLLOW_17_in_relativePeriodFutureOptions193 = new BitSet(
			new long[] { 0x0000000000000002L });
	public static final BitSet FOLLOW_Number_in_absoluteDate237 = new BitSet(
			new long[] { 0x0000000000000002L });

}